Summary: Ganglia Distributed Monitoring System
Name: ganglia
Version: 3.0.7
URL: http://ganglia.info/
Release: 1
License: BSD
Vendor: Ganglia Development Team <ganglia-developers@lists.sourceforge.net>
Group: System Environment/Base

Source0: %{name}-%{version}.tar.gz
Source1: %{name}-%{version}-patch-ibm-power.tar.gz

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Ganglia is a scalable, real-time monitoring and execution environment


%package gmond
Summary: Ganglia Monitor daemon http://ganglia.sourceforge.net/
Group: System Environment/Base
Obsoletes: ganglia-monitor-core-gmond ganglia-monitor-core

%description gmond
Ganglia is a scalable, real-time monitoring and execution environment
with all execution requests and statistics expressed in an open
well-defined XML format.

This gmond daemon provides the ganglia service within a single cluster or
Multicast domain.


%package devel
Summary: Ganglia Library http://ganglia.sourceforge.net/
Group: System Environment/Base
Obsoletes: ganglia-monitor-core-lib 

%description devel
The Ganglia Monitoring Core library provides a set of functions that programmers
can use to build scalable cluster or grid applications.


##
## PREP
##
%prep 
%setup -q
gzip -dc %{SOURCE1} | tar -xvf -


##
## BUILD
##
%build
export CC=gcc
./configure \
    --prefix=%{_prefix} \
    --disable-shared --enable-static
make %{?_smp_mflags}


##
## PRE
##
%pre


##
## PREUN GMOND
##
%preun gmond
if [ "$1" = 0 ]
then
   /etc/rc.d/init.d/gmond stop
fi


##
## POST GMOND
##
%post gmond
if [ "$1" -gt "1" ]; then
   # Upgrading ganglia package - restart gmond
   /etc/rc.d/init.d/gmond restart
fi


##
## INSTALL
##
%install

[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

## Create the directory structure
%__mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
%__mkdir -p $RPM_BUILD_ROOT%{_mandir}/man5

## Move the files into the structure
%__cp -f %{_builddir}/%{name}-%{version}/gmond/gmond.aix.init $RPM_BUILD_ROOT/etc/rc.d/init.d/gmond
chmod 0755 $RPM_BUILD_ROOT/etc/rc.d/init.d/gm*
# We just output the default gmond.conf from gmond using the '-t' flag
%{_builddir}/%{name}-%{version}/gmond/gmond -t > $RPM_BUILD_ROOT/etc/gmond.conf

%__cp -f %{_builddir}/%{name}-%{version}/gmond/gmond.conf.5 $RPM_BUILD_ROOT/opt/freeware/man/man5/gmond.conf.5

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc2.d/
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc3.d/
ln -sf '../init.d/gmond' $RPM_BUILD_ROOT/etc/rc.d/rc2.d/Sgmond
ln -sf '../init.d/gmond' $RPM_BUILD_ROOT/etc/rc.d/rc2.d/Kgmond
ln -sf '../init.d/gmond' $RPM_BUILD_ROOT/etc/rc.d/rc3.d/Sgmond
ln -sf '../init.d/gmond' $RPM_BUILD_ROOT/etc/rc.d/rc3.d/Kgmond


##
## FILES GMOND
##
%files gmond
%defattr(-,root,system)
%attr(0500,root,system) %{_bindir}/gmetric
%attr(0555,root,system) %{_bindir}/gstat
%{_sbindir}/gmond
%attr(0644,root,system) %{_mandir}/man5/gmond.conf.5*
%config(noreplace) /etc/gmond.conf
/etc/rc.d/init.d/gmond
/etc/rc.d/rc2.d/Sgmond
/etc/rc.d/rc2.d/Kgmond
/etc/rc.d/rc3.d/Sgmond
/etc/rc.d/rc3.d/Kgmond


##
## FILES DEVEL
##
%files devel
%defattr(-,root,system)
%{_bindir}/ganglia-config
%{_includedir}/ganglia.h
%{_libdir}/libganglia*


##
## CLEAN
##
%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT


##
## CHANGELOG
##
%changelog
* Tue Mar 25 2008 Michael Perzl <michael@perzl.org> - 3.0.7-1
- updated for Ganglia v3.0.7
* Tue Mar 25 2008 Michael Perzl <michael@perzl.org> - 3.0.6-1
- updated for Ganglia v3.0.6
* Mon Oct 08 2007 Michael Perzl <michael@perzl.org>
- updated for Ganglia v3.0.5
* Wed Jul 11 2007 Michael Perzl <michael@perzl.org>
- fixed the network counter overflow error on AIX
* Wed Jan 10 2007 Michael Perzl <michael@perzl.org>
- adapted for Ganglia v3.0.4
* Fri Apr 21 2006 Michael Perzl <michael@perzl.org>
- adapted for Ganglia v3.0.3
* Thu Feb 23 2006 Michael Perzl <michael@perzl.org>
- first version for AIX V5.1 and higher
* Fri Dec 10 2004 Matt Massie <massie@cs.berkeley.edu>
- Updated the spec file for 2.6.0 release
* Tue Apr 13 2004 Brooks Davis <brooks@one-eyed-alien.net>
- Use the autoconf variable varstatedir instead of /var/lib for consistancy.
* Thu Feb 19 2004 Matt Massie <massie@cs.berkeley.edu>
- Removed the /usr/include/ganglia directory from the lib rpm and
  changed the deprecated Copyright to License
* Mon Oct 14 2002 Federico Sacerdoti <fds@sdsc.edu>
- Split package into -gmetad and -gmond subpackages for clarity,
  and separation of purpose/functionality.
* Thu Sep 19 2002 Federico Sacerdoti <fds@sdsc.edu>
- Added config files, made /var/lib/ganglia for RRD storage.
* Mon Mar 11 2002 Matt Massie <massie@cs.berkeley.edu>
- Added support for libganglia, added Prefix: for RPM relocation
* Wed Feb 27 2002 Matt Massie <massie@cs.berkeley.edu>
- Merge gmetric and gmond together into one RPM.  Fix some small bugs.
* Fri Nov  2 2001 Matt Massie <massie@cs.berkeley.edu>
- initial release
